#!/usr/bin/env python3
""" Statistical Language processing, Assignment 6
	See <https://snlp2021.github.io/a6/> for detailed instructions.

	<Please insert your name and the honor code here.>
"""

from nltk.metrics.distance import edit_distance

def str_distance(gold, pred, average=True):
	"""Calculates the average normalized edit distance for inflection task.

	Parameters:
	-----------
	gold:   A sequence containing all acceptable inflections (strings).
			For example, [['Monitore', 'Monitoren'], ['Computer']]
			means both Monitore and Monitoren are both acceptable for the
			first item, while only Computer is acceptable for the
			second.
	pred:   Predicted forms, e.g., ['Monitoren', 'Computer'] for the
			above example. There should be a single prediction for
			each lemma.
	"""
	sum_dist = 0
	for  i, pw in enumerate(pred):
		# take the minimum distance to the acceptable inflections
		gw = gold[i][0]
		d = edit_distance(gw, pw)
		for w in gold[i][1:]:
			dd = edit_distance(w, pw)
			if dd < d:
				gw, d = w, dd
		if average:
			d /=  max(len(pw), len(gw))
		print(pw, gw, d)
		sum_dist +=  d
	return  sum_dist / len(pred)

def inflect(trn_lemma, trn_gender, trn_words, tst_lemma, tst_gender):
	"""Main interface to the assignment.

	This function should perform all necessary steps to train your
	inflection model on (trn_lemma, trn_gender, trn_words) and
	return predictions for (tst_lemma, tst_gender).

	Do not tune your model here. Instead, use your best setup to only
	train and return the predictions for the test set. You will lose
	points if this function takes too long (more than 15 minutes on a
	standard desktop).
	"""
	pass

if __name__ == "__main__":
	pass
